Package org.springframework.web.server

# Class MethodNotAllowedException

java.lang.Object
java.lang.Throwable
java.lang.Exception
java.lang.RuntimeException
org.springframework.core.NestedRuntimeException
org.springframework.web.ErrorResponseException
org.springframework.web.server.ResponseStatusException
org.springframework.web.server.MethodNotAllowedException

All Implemented Interfaces:
  `Serializable`, `ErrorResponse`

public class MethodNotAllowedException extends ResponseStatusException
Exception for errors that fit response status 405 (method not allowed).

Since:
  5.0
Author:
  Rossen Stoyanchev
See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.springframework.web.ErrorResponse

`ErrorResponse.Builder, ErrorResponse.Interceptor`

## Constructor Summary

Constructors
Constructor
Description
`MethodNotAllowedException(String method, Collection<HttpMethod> supportedMethods)`
`MethodNotAllowedException(HttpMethod method, Collection<HttpMethod> supportedMethods)`

## Method Summary

Modifier and Type
Method
Description
`HttpHeaders`
`getHeaders()`
Return HttpHeaders with an "Allow" header that documents the allowed HTTP methods for this URL, if available, or an empty instance otherwise.
`String`
`getHttpMethod()`
Return the HTTP method for the failed request.
`HttpHeaders`
`getResponseHeaders()`
Deprecated.
as of 6.0 in favor of `getHeaders()`
`Set<HttpMethod>`
`getSupportedMethods()`
Return the list of supported HTTP methods.

### Methods inherited from class org.springframework.web.server.ResponseStatusException

`getMessage, getReason, updateAndGetBody`

### Methods inherited from class org.springframework.web.ErrorResponseException

`getBody, getDetailMessageArguments, getDetailMessageCode, getStatusCode, setDetail, setInstance, setTitle, setType`

### Methods inherited from class org.springframework.core.NestedRuntimeException

`contains, getMostSpecificCause, getRootCause`

### Methods inherited from class java.lang.Throwable

`addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.springframework.web.ErrorResponse

`getDetailMessageArguments, getTitleMessageCode, getTypeMessageCode`

## Constructor Details

### MethodNotAllowedException

public MethodNotAllowedException(HttpMethod method, Collection<HttpMethod> supportedMethods)

### MethodNotAllowedException

public MethodNotAllowedException(String method, @Nullable Collection<HttpMethod> supportedMethods)

## Method Details

### getHeaders

public HttpHeaders getHeaders()
Return HttpHeaders with an "Allow" header that documents the allowed HTTP methods for this URL, if available, or an empty instance otherwise.

Specified by:
  `getHeaders` in interface `ErrorResponse`
Overrides:
  `getHeaders` in class `ResponseStatusException`

### getResponseHeaders

@Deprecated(since="6.0") public HttpHeaders getResponseHeaders()
Deprecated.
as of 6.0 in favor of `getHeaders()`
Delegates to `getHeaders()`.

Overrides:
  `getResponseHeaders` in class `ResponseStatusException`
Since:
  5.1.13

### getHttpMethod

public String getHttpMethod()
Return the HTTP method for the failed request.

### getSupportedMethods

public Set<HttpMethod> getSupportedMethods()
Return the list of supported HTTP methods.